//////////////////////////////
// add_spouce.c
// written by Michael Gibson
// released under the GPL
// enter the spouce of an individual
// copyright 2005-2015
//////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"

 void readfile(void);
 void writefile(void);

 char indi_name_s[95];
 int  indi_name;
 char indi_sname_s[95];
 int  indi_sname;
 char indi_sex_s[3];
 int  indi_sex;
 char indi_birthdate_s[90];
 int  indi_birthdate;
 char indi_birthplac_s[90];
 int  indi_birthplac;
 char fami_marrdate[90];
 int  fami_marrdate_i;
 char fami_marrplac[190];
 int  fami_marrplac_i;
 char fami_marrnote[256];
 int  fami_marrnote_i;

 int  fami_div_date_i;
 char fami_div_date[90];



 char indi_check[55];
 int indi_passed;             //last individual number read/passed in
 int last_read_indi;
 int newid;                   //id of the individual being added
 int last_read_fami;
 int newfami;                 //id of the new family created

 char filename[55];
 char temp[90];               //data that is read in and evaluated

 int number_of_names;
 int number_of_lines;
 int family_begin;
 int x; //loop var

 //for up to 99999 lines read in at the length up to 80
 char data_line[99999][80];


////////////////////////////////////////
//
//////////////////////////////////////
static void submit(void)
{

  char string_1[50];

  //printf("submit pressed \n");

  writefile();

  system("killall gedlist");
  sprintf(string_1,"./gedlist %s &",filename);
  //printf("%s\n",string_1);
  system(string_1);
  exit(0);
}

/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}


//////////////////////////////////////////////////
// main
/////////////////////////////////////////////////
int main(int argc, char **argv){


  int  dad_image, mom_image;

  char input1[95], input2[95];
  int individual;
  int button_01, button_02, button_03;
  int label0,label1,label2,label3,label4,label5,label6,label7,label8;
  char label_string1[60];
  char label_string2[60];
  int flag1=0;
  int x=0;
  int line=5;
  int indi_found=0;

  int loopy=0;

  FILE *fp5;

  strcpy(filename, argv[2]);
  readfile();

  //printf("Start GUI\n");

  x_open();

  /* create a new window */
  gdx_window("GEDCOM Add Spouce",790,520);
  gdx_setwindowbg("images/bg.xpm",1);

  button_01 = gdx_imagebutton(5,10,"images/close.xpm",destroy);
  button_02 = gdx_imagebutton(5,40,"images/filesave.xpm",submit);
  button_03 = gdx_imagebutton(55,340,"images/submit.xpm",submit);
  
  sprintf(label_string1,"Saving to filename %s",argv[2]);
  label0 = gdx_label(label_string1,55,15,1);
  gdx_setlabelbg("images/white.xpm",1,label0);

  sprintf(label_string2,"Spouce of id %s",argv[1]);
  label7 = gdx_label(label_string2,55,30,1);
  gdx_setlabelbg("images/white.xpm",1,label7);  

  //printf("%s %s %s\n",argv[0],argv[1],argv[2]);

  indi_passed=atoi(argv[1]);

  gdx_image(55,50,"images/spouce.xpm");

  //entry first

  label1 = gdx_label("Given Name:",55,95,0);
  gdx_setlabelbg("images/bg.xpm",1,label1);
  indi_name=gdx_textentry(145,85,200,0);

  label2=gdx_label("Surname:",55,120,0);
  gdx_setlabelbg("images/bg.xpm",1,label2);
  indi_sname=gdx_textentry(145,110,200,0);

  label3=gdx_label("Birth Date:",55,145,0);
  gdx_setlabelbg("images/bg.xpm",1,label3); 
  indi_birthdate=gdx_textentry(145,135,100,0);

  label4=gdx_label("Birth Place:",55,170,0);
  gdx_setlabelbg("images/bg.xpm",1,label4);
  indi_birthplac=gdx_textentry(145,160,275,0);

  label5=gdx_label("Sex:",55,195,0);
  gdx_setlabelbg("images/bg.xpm",1,label5);
  indi_sex=gdx_textentry(145,185,20,0);
  gdx_settextentry(indi_sex,argv[3]);

  gdx_frame(55,220,500,330,"If Spouce - Marriage");


  label6=gdx_label("Marriage Date:",65,245,0);
  gdx_setlabelbg("images/bg.xpm",1,label6);
  fami_marrdate_i=gdx_textentry(165,235,100,0);

  label7=gdx_label("Marriage Place:",65,270,0);
  gdx_setlabelbg("images/bg.xpm",1,label7);
  fami_marrplac_i=gdx_textentry(165,260,275,0);

  label8=gdx_label("Marriage Note:",65,295,0);
  gdx_setlabelbg("images/bg.xpm",1,label8);
  fami_marrnote_i=gdx_textentry(165,285,325,0);


  gdx_main();
  x_close();

  return(0);
}


////////////////////////////////////////////////////////
// read file
////////////////////////////////////////////////////////

void readfile(void)
{

  int theend=0;      //if end of data found, stop reading

  int familyfound=0; //if a family is found, stop looking

  FILE *fp; 
  if((fp=fopen(filename,"r"))==NULL ){
     printf("GEDCOM add spouce : Sorry, no file found. \n");
     exit(0);
  }
  number_of_names = 0;
  number_of_lines = 0;
  do{
    fgets(temp,80,fp);
    number_of_lines++;
    strcpy(data_line[number_of_lines],temp);

    //clean up returns
    for(x=0;x<80;x++){
      if(temp[x]=='\r' || temp[x]=='\n'){
         temp[x]= ' ';
      }
    }

    // Look for indivduals
    if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){         //Individual 0 level start of record
      temp[0]=' ';
      for(x=0;x<80;x++){
        if(temp[x]=='@' || temp[x]=='I' ||temp[x]=='N' ||temp[x]=='D') temp[x]=' ';
      }
      last_read_indi=atoi(temp);
      number_of_names++;
    } //end if


   //Look for family start
   if(temp[0]=='0' && temp[2]=='@' && temp[3]=='F' && familyfound==0){
     family_begin=number_of_lines;
     familyfound=1;
   }

  //look for last family id
   if(temp[0]=='0' && temp[2]=='@' && temp[3]=='F'){
      temp[0]=' ';
      for(x=0;x<80;x++){
        if(temp[x]=='@' || temp[x]=='F' ||temp[x]=='A' ||temp[x]=='M' || temp[x]=='I') temp[x]=' ';
      }
      last_read_fami=atoi(temp);
   }

   //find end
   if(temp[0] == '0' && temp[2] == 'T' && temp[3] == 'R'){
     theend=1;
   }
  //printf(".");

  }while (theend != 1); //end do

  //printf("\nNumber of lines = %d \n",number_of_lines);
  //printf("Number of names = %d \n",number_of_names);
  //printf("Last read ID=%d \n",last_read_indi);
  newid=last_read_indi + 1;
  //printf("Last read family ID=%d \n",last_read_fami);
  newfami=last_read_fami + 1;
  //printf("new person to have ID of %4d \n",newid);
  //printf("new family to have ID of %4d \n",newfami);
  //printf("Line %d is where families begin \n",family_begin);
  //lastline
}


//////////////////////////////
//
/////////////////////////////
void writefile(void)
{
  char fami_string[15];
  char husb_string[15];
  char wife_string[15];
  char spou_string[15];
  char marr_string[15];

  int y; // loop var

  char indi[10];
  int indi_r;

  char fam_lnk[15];     //indivudual's link to family
 
  char spou_name[80];
  char spouce_sex[3];

  char f_bd[20];
  char f_bp[90];

  //collect data from text entry widgets
  strcpy(indi_name_s , gdx_textentry_obj.string[indi_name]);
  strcpy(indi_sname_s   , gdx_textentry_obj.string[indi_sname]);
  strcpy(indi_sex_s   , gdx_textentry_obj.string[indi_sex]);
  strcpy(indi_birthdate_s  , gdx_textentry_obj.string[indi_birthdate]);
  strcpy(fami_marrdate,  gdx_textentry_obj.string[fami_marrdate_i]);
  strcpy(fami_marrplac, gdx_textentry_obj.string[fami_marrplac_i]);
  strcpy(fami_marrnote, gdx_textentry_obj.string[fami_marrnote_i]);

  //shift data to write new individual
  for(x=number_of_lines;x>=family_begin;x--){
    strcpy(data_line[x+7],data_line[x]);
  }

  number_of_lines = number_of_lines +7;

  //format the new data to write
  //spouce first
  //format:
  // 0 @I0001@ INDI
  // 1 NAME Billy Bob /Johnson/
  // 1 SEX M
  // 1 BIRT
  // 2 DATE 10 Jun 1959
  // 2 PLAC some place
  // 1 FAMS @F0009@

  sprintf(spou_string,"0 @I%04d@ INDI\n",newid);
  strcpy(data_line[family_begin],spou_string);
  sprintf(spou_name,"1 NAME %s /%s/ \n",indi_name_s,indi_sname_s);
  strcpy(data_line[family_begin+1],spou_name);

  sprintf(spouce_sex,"1 SEX %s\n",indi_sex_s);
  strcpy(data_line[family_begin+2],spouce_sex);

  strcpy(data_line[family_begin+3],"1 BIRT\n");

  sprintf(f_bd,"2 DATE %s\n",indi_birthdate_s);
  strcpy(data_line[family_begin+4],f_bd);

  sprintf(f_bp,"2 PLAC %s\n",indi_birthplac_s);
  strcpy(data_line[family_begin+5],f_bp);

  sprintf(fam_lnk,"1 FAMS @F%04d@\n",newfami);
  strcpy(data_line[family_begin+6],fam_lnk);


  // 0 @F0151@ FAM
  // 1 HUSB @I0403@
  // 1 WIFE @I0426@
  // 1 MARR
  // 2 DATE 2 Jun 2007
  // 2 PLAC some place
  //family
  sprintf(fami_string,"0 @F%04d@ FAM\n",newfami);
  strcpy(data_line[number_of_lines],fami_string);


if(indi_sex_s[0]=='M'){
  sprintf(husb_string,"1 HUSB @I%04d@\n",newid);
  strcpy(data_line[number_of_lines+1],husb_string); 

  sprintf(wife_string,"1 WIFE @I%04d@\n",indi_passed);
  strcpy(data_line[number_of_lines+2],wife_string);
}

if(indi_sex_s[0]=='F'){
  sprintf(husb_string,"1 HUSB @I%04d@\n",indi_passed);
  strcpy(data_line[number_of_lines+1],husb_string);
  
  sprintf(wife_string,"1 WIFE @I%04d@\n",newid);
  strcpy(data_line[number_of_lines+2],wife_string);
}


  strcpy(data_line[number_of_lines+4],"1 MARR\n");
  sprintf(marr_string,"2 DATE %s\n",fami_marrdate);
  strcpy(data_line[number_of_lines+5],marr_string);
  sprintf(marr_string,"2 PLAC %s\n",fami_marrplac);
  strcpy(data_line[number_of_lines+6],marr_string);

  sprintf(marr_string,"2 NOTE %s\n",fami_marrnote);
  strcpy(data_line[number_of_lines+7],marr_string);

  strcpy(data_line[number_of_lines+8],"0 TRLR\n");

  FILE *fp;
  if((fp=fopen(filename,"w"))==NULL ){
     printf("GEDCOM add spouce : Sorry, no file found. \n");
     exit(0);
  }


  //write data
  for(x=1;x<=number_of_lines+8;x++){

    //find place to write child entry under indivdual if an
    //individual follows

    //copy to evaluated
    strcpy(temp,data_line[x]);

    //is this line an idividual?
    if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){

      //if yes, remove unimportant charcters
      //read in the id number
      sprintf(indi,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      indi_r=atoi(indi);
      //is this the indivudual after the child?
      if(indi_r == (indi_passed +1)){
        //if yes, add child link
        sprintf(data_line[x],"1 FAMS @F%04d@\n%s",newfami,temp);
      }
    }
    //write_data
   // printf("line %d ::%s::",x,data_line[x]);
    fprintf(fp,"%s",data_line[x]);
  }
  fclose(fp);
}
