//////////////////////////////
// search_prompt.c
// written by Michael Gibson
// released under the GPL
// enter the event
// copyright 2009
//////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"

char *error_msg;

////////////////////////
//// error message
////////////////////////
void quick_message(void) {

  x_msgbox(5,error_msg,"Error","fixed",50);

}


 int param_i;                 // not used yet, for future
 char filename[55];
 char searchname_s[55];       // stored name
 int  searchname;             // widget pointer
 char temp[99];               // data that is read in and evaluated

 int number_of_lines;

 //for up to 99999 lines read in at the length up to 99
 char data_line[99999][99];

////////////////////////////////////////
//
//////////////////////////////////////
static void submit(void)
{

  char string_1[50];

  //printf("submit pressed \n");
  strcpy(searchname_s,gdx_textentry_obj.string[searchname]);
  sprintf(string_1,"./gedsearch %s %s",searchname_s ,filename);
  printf("exec'n %s \n",string_1);
  system(string_1);  

  gdx_closewindow();
  exit(0);
}

/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}


//////////////////////////////////////////////////
// main
/////////////////////////////////////////////////
int main(int argc, char **argv){

  char input1[95], input2[95];
  int button_01, button_02;
  int label0,label1,label2;
  char label_string1[60];
  char label_string2[60];
  int x=0;

  FILE *fp;

  strcpy(filename, argv[2]);

  //printf("Start GUI\n");

  x_open();

  /* create a new window */
  gdx_window("GEDCOM Search",400,200);
  gdx_setwindowbg("images/bg.xpm",1);

  button_01 = gdx_imagebutton(5,10,"images/close.xpm",destroy);
  button_02 = gdx_imagebutton(55,160,"images/go_btn.xpm",submit);

  sprintf(label_string1,"Searching filename %s",argv[2]);
  label0 = gdx_label(label_string1,55,25,1);
  gdx_setlabelbg("images/white.xpm",1,label0);


  printf("app=%s id=%s filename=%s \n",argv[0],argv[1],argv[2]);

  param_i=atoi(argv[1]);
  

  // Labels

  label1=gdx_label("Search for individuals by surname",55,55,0);
  gdx_setlabelbg("images/bg.xpm",1,label1);


  label2=gdx_label("Surname:",55,85,0);
  gdx_setlabelbg("images/bg.xpm",1,label2); 


  // entry
  searchname=gdx_textentry(145,75,160,0);


  gdx_main();
  x_close();

  return(0);
}


