//////////////////////////////
// gdx_indi.c
// written by Michael Gibson
// released under the GPL
// copyright 2007-2009
//////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"

 char indi_check[55];
 char filename[55];
 char indi_num[6];
 int number_of_lines=0;

char data_line[9999][9999];
  char last_action[15];

  char indi_name[95];
  char indi_name_tmp[95];
  int  indi_name_t;

  char indi_buri_note[95];
  int  indi_buri_note_t;
  char indi_crem_note[95];
  int  indi_crem_note_t;
  char indi_deat_note[95];
  int  indi_deat_note_t;
  char indi_buri_date[90];
  int  indi_buri_date_t;
  char indi_buri_plac[90];
  int  indi_buri_plac_t;
  char indi_deat_date[90];
  int  indi_deat_date_t;
  char indi_deat_plac[90];
  int  indi_deat_plac_t;
  char indi_deat_sour[90];
  int  indi_deat_sour_t;
  char indi_buri_sour[90];
  int  indi_buri_sour_t;
  char indi_crem_date[90];
  int  indi_crem_date_t;
  char indi_crem_plac[90];
  int  indi_crem_plac_t;



/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}



//////////////////////////////
// save
// save individual data
/////////////////////////////
void save(void)
{
  FILE *fp;
  int data_written=0;       //any data written

  int name_written=0;
  int name_needs_written=0;
  int deat_written=0;
  int deat_needs_written=0;
  int buri_written=0;
  int buri_needs_written=0;
  int crem_written=0;
  int crem_needs_written=0;

  char temp[95];
  char check_string1[15];
  char check_string2[15];
  int x=0;
  int y=0; // loop var
  char indi[10];
  int indi_r=0;
  int write_indi=0;

  //collect data from text entry widgets
  strcpy(indi_name_tmp, gdx_textentry_obj.string[indi_name_t]);
  strcpy(indi_deat_plac, gdx_textentry_obj.string[indi_deat_plac_t]);
  strcpy(indi_deat_date, gdx_textentry_obj.string[indi_deat_date_t]);
  strcpy(indi_deat_note, gdx_textentry_obj.string[indi_deat_note_t]);
  strcpy(indi_buri_plac, gdx_textentry_obj.string[indi_buri_plac_t]);
  strcpy(indi_buri_date, gdx_textentry_obj.string[indi_buri_date_t]);
  strcpy(indi_buri_note, gdx_textentry_obj.string[indi_buri_note_t]);
  strcpy(indi_crem_plac, gdx_textentry_obj.string[indi_crem_plac_t]);
  strcpy(indi_crem_date, gdx_textentry_obj.string[indi_crem_date_t]);
  strcpy(indi_crem_note, gdx_textentry_obj.string[indi_crem_note_t]);
 
  //if the field contains data and the data has changed
  if(strlen(indi_name_tmp) >= 2 && strcmp(indi_name,indi_name_tmp)!=0) name_needs_written=1;
  if(strlen(indi_deat_date) >= 2 || strlen(indi_deat_plac) >= 2 || strlen(indi_deat_note) >= 2 ) deat_needs_written=1;
  if(strlen(indi_buri_plac) >= 2 || strlen(indi_buri_date) >= 2 || strlen(indi_buri_note) >= 2 ) buri_needs_written=1;
  if(strlen(indi_crem_plac) >= 2 || strlen(indi_crem_date) >= 2 || strlen(indi_crem_note) >= 2 ) crem_needs_written=1;

/// now for updated data ///

  if((fp=fopen(filename,"w"))==NULL ){
     printf("GEDCOM add event : Sorry, no file found. \n");
     exit(0);
  }

  //write data
  for(x=0;x<=number_of_lines;x++){
    strcpy(temp,data_line[x]);

    //is this line an idividual?
    if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){
      //if yes, remove unimportant charcters
      //read in the id number
      sprintf(indi,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      indi_r=atoi(indi);
      //is this the indivudual ?
      if(indi_r == atoi(indi_num)) {
        write_indi=1;
        printf("lets write....\n");
      }
      if(indi_r != atoi(indi_num)) write_indi=0;
    }
    //1 NAME
    if(temp[0]=='1' && temp[2]=='N' && temp[3]=='A' && temp[4]=='M' && write_indi==1){
        sprintf(data_line[x],"1 NAME %s\n",indi_name_tmp);
        data_written=1;
        name_written=1;
        strcpy(indi_name,indi_name_tmp);
    }

    // 1 DEAT
    if(temp[0]=='1' && temp[2]=='D' && temp[3]=='E' && temp[4]=='A' && write_indi==1){
      deat_needs_written=0;  //temp fix
    }
   // 1 BURI
    if(temp[0]=='1' && temp[2]=='B' && temp[3]=='U' && temp[4]=='R' && write_indi==1){
      buri_needs_written=0;  //temp fix
    }
   // 1 CREM
    if(temp[0]=='1' && temp[2]=='C' && temp[3]=='R' && temp[4]=='E' && write_indi==1){
      crem_needs_written=0;  //temp fix
    }

    //write_data
    fprintf(fp,"%s",data_line[x]);
  }//end for
  fclose(fp);

/// Now for new data ////

 if((fp=fopen(filename,"w"))==NULL ){
     printf("GEDCOM add event : Sorry, no file found. \n");
     exit(0);
  }

  //write data
  for(x=0;x<=number_of_lines;x++){
    strcpy(temp,data_line[x]);

    //is this line an idividual?
    if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){
      //if yes, remove unimportant charcters
      //read in the id number
      sprintf(indi,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      indi_r=atoi(indi);
      //is this the indivudual ?
      if(indi_r == atoi(indi_num)) {
        write_indi=1;
        printf("lets write....\n");
      }
      if(indi_r != atoi(indi_num)) write_indi=0;
    }

    //1 DEAT after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&deat_written==0&&deat_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 DEAT\n2 DATE %s\n2 PLAC %s\n2 NOTE %s\n",temp,indi_deat_date,indi_deat_plac,indi_deat_note);
        strcpy(data_line[x],temp);
        data_written=1;
    }

    //1 BURI after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&buri_written==0&&buri_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 BURI\n2 DATE %s\n2 PLAC %s\n2 NOTE %s\n",temp,indi_buri_date,indi_buri_plac,indi_buri_note);
        strcpy(data_line[x],temp);
        data_written=1;
    }


   //1 CREM after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&crem_written==0&&crem_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 CREM\n2 DATE %s\n2 PLAC %s\n2 NOTE %s\n",temp,indi_crem_date,indi_crem_plac,indi_crem_note);
        strcpy(data_line[x],temp);
        data_written=1;
    }


    //write_data
    fprintf(fp,"%s",data_line[x]);
  }//end for
  fclose(fp);

  if(data_written==1) x_msgbox(5,"Data has been saved","Saved","fixed",50);


}

//////////////////////////////////////////////////
// main
/////////////////////////////////////////////////
int main(int argc, char **argv){


  char input1[95], input2[95];
  //int individual;
  int button_01, button_02, button_03, button_04, button_05;
  int button_06, button_08;
  int label0,label1,label2,label3,label4,label5,label6;
  int label24,label25,label26,label33;
  int label7,label8,label9,label10,label11, label12, label13;
  int flag1=0;
  int x=0;
  int line=5;
  int indi_found=0;

  int loopy=0;

  FILE *fp5;

  strcpy(filename, argv[1]);
  strcpy(indi_buri_date,"\0");
  strcpy(indi_buri_plac,"\0");
  strcpy(indi_deat_plac,"\0");
  strcpy(indi_deat_date,"\0");
  strcpy(indi_buri_plac,"\0");
  strcpy(indi_deat_note,"\0");
  strcpy(indi_buri_note,"\0");
  strcpy(indi_crem_plac,"\0");
  strcpy(indi_crem_date,"\0");
  strcpy(indi_crem_note,"\0");
 
  fp5=fopen(argv[1],"r+");

  x_open();

  /* create a new window */
  gdx_window("GEDCOM Individual - Death",790,520);


  gdx_setwindowbg("images/bg.xpm",1);


  gdx_frame(50,18,515,460,"Individual data for GEDCOM ID:");

  button_01 = gdx_imagebutton(5,10,"images/close.xpm",destroy);

  button_06 = gdx_imagebutton(5,48,"images/filesave.xpm",save);
  button_08 = gdx_imagebutton(45,485,"images/submit.xpm",save);

  label0 = gdx_label(argv[2],240,15,1);
  gdx_setlabelbg("images/white.xpm",1,label0);

  printf("%s %s %s\n",argv[0],argv[1],argv[2]);

  do{

    loopy++;

    //check for level 0

    fgets(input1,80,fp5);

    if (input1[0]=='0'){ //OK, we have a level 0
      //check for an individual
      //01234567890123
      //0 @I0001@ INDI

      if(input1[2]=='@' && input1[3]=='I' && input1[10]=='I' && input1[11]=='N'){
        indi_found=1;
      }

      if(indi_found==1){
        //Great!, the level 0 is an individual

        for(x=5;x<80;x++) if(input1[x]=='@' ||input1[x]=='I') input1[x]=' ';
        sprintf(indi_check,"%c%c%c%c",input1[4],input1[5],input1[6],input1[7]);

        //check to see if it is the idividual we are looking for 
        //printf("check '%s' = '%s'\n",indi_check,argv[2]);
        if(atoi(indi_check)==atoi(argv[2])){
          //hot grits! it is the idividual we were looking for
          //now read in the individual's information
          do{

            fgets(input1,80,fp5);

            if(input1[0]=='1' && input1[2]=='N' && input1[3]=='A'){     ///1 NAME
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];}
              strcpy(indi_name,input1);
            }



// last actions

            if(input1[0]=='1' && input1[2]=='C' && input1[3]=='H' && input1[4] =='A'){ //1 CHAN
               strcpy(last_action,"CHAN");
            }

            if(input1[0]=='1' && input1[2]=='E' && input1[3]=='V' && input1[4] =='E'){ //1 EVEN
              strcpy(last_action,"EVEN");
            }

            if(input1[0]=='1' && input1[2]=='B' && input1[3]=='U' && input1[4] =='R'){ //1 BURI
              strcpy(last_action,"BURI");
            }

            if(input1[0]=='1' && input1[2]=='C' && input1[3]=='R' && input1[4] =='E'){ //1 CREM
              strcpy(last_action,"CREM");
            }

            if(input1[0]=='1' && input1[2]=='B' && input1[3]=='I' && input1[4] =='R'){ //1 BIRT
               strcpy(last_action,"BIRT");
            }

            if(input1[0]=='1' && input1[2]=='D' && input1[3]=='E' && input1[4] =='A'){ //1 DEAT
              strcpy(last_action,"DEAT");
            }

// Burial,cren Date and Death Date

           if(input1[0]=='2' && input1[2]=='D' && input1[3]=='A'){ //2 DATE
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];
              }
              if(last_action[0]=='B' && last_action[1]=='U'){
                strcpy(indi_buri_date,input1);
              }
              if(last_action[0]=='C' && last_action[1]=='R'){
                strcpy(indi_crem_date,input1);
              }
              if(last_action[0]=='D' && last_action[1]=='E'){
                strcpy(indi_deat_date,input1);
              }
           }

// Brith Place and Death Place
 
           if(input1[0]=='2' && input1[2]=='P' && input1[3]=='L'){ //2 PLAC
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];
              }
              if(last_action[0]=='B' && last_action[1]=='U'){
                strcpy(indi_buri_plac,input1);
              }
              if(last_action[0]=='C' && last_action[1]=='R'){
                strcpy(indi_crem_plac,input1);
              }
              if(last_action[0]=='D' && last_action[1]=='E'){
                strcpy(indi_deat_plac,input1);
              }
           }


// Buri Note and Death Note

           if(input1[0]=='2' && input1[2]=='N' && input1[3]=='O'){ //2 Note 
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];
              }
              if(last_action[0]=='B' && last_action[1]=='U'){
                strcpy(indi_buri_note,input1);
              }
              if(last_action[0]=='C' && last_action[1]=='R'){
                strcpy(indi_crem_note,input1);
              }
              if(last_action[0]=='D' && last_action[1]=='E'){
                strcpy(indi_deat_note,input1);
              }
           }


          //stop when I get to the next idividual

          }while(input1[0] != '0' );

          flag1=22;
        }
      }//if indi

    }//if 0 level

    if(input1[0]=='\0'){

      flag1=22;
      gdx_label("File read error!",50,50,1);
      printf("NULL found!");
    }
   
  }while(flag1!=22);

  //display
  //Name
  label1 = gdx_label("Name:",60,35,0);
  gdx_setlabelbg("images/bg.xpm",1,label1);
  indi_name_t=gdx_textentry(145,25,250,0);
  gdx_settextentry(indi_name_t,indi_name);


  //Burial Date
  label3=gdx_label("Burial Date:",60,160,0);
  gdx_setlabelbg("images/bg.xpm",1,label3);
  indi_buri_date_t=gdx_textentry(145,150,100,0);
  gdx_settextentry(indi_buri_date_t,indi_buri_date);

  //Burial Place
  label4=gdx_label("Burial Place:",60,185,0);
  gdx_setlabelbg("images/bg.xpm",1,label4);
  indi_buri_plac_t=gdx_textentry(145,175,350,0);
  gdx_settextentry(indi_buri_plac_t,indi_buri_plac);

  label12 = gdx_label("Burial Note:",60,210,0);
  gdx_setlabelbg("images/bg.xpm",1,label12);
  indi_buri_note_t=gdx_textentry(145,200,350,0);
  gdx_settextentry(indi_buri_note_t,indi_buri_note);


  //Death Date
  label5=gdx_label("Death Date:",60,60,0);
  gdx_setlabelbg("images/bg.xpm",1,label5);
  indi_deat_date_t=gdx_textentry(145,50,100,0);
  gdx_settextentry(indi_deat_date_t,indi_deat_date);

  label6=gdx_label("Death Place:",60,85,0);
  gdx_setlabelbg("images/bg.xpm",1,label6);
  indi_deat_plac_t=gdx_textentry(145,75,350,0);
  gdx_settextentry(indi_deat_plac_t,indi_deat_plac);

  label13 = gdx_label("Death Note:",60,110,0);
  gdx_setlabelbg("images/bg.xpm",1,label13);
  indi_deat_note_t=gdx_textentry(145,100,350,0);
  gdx_settextentry(indi_deat_note_t,indi_deat_note);


  //Cremation Date
  label25=gdx_label("Crem. Date:",60,260,0);
  gdx_setlabelbg("images/bg.xpm",1,label25);
  indi_crem_date_t=gdx_textentry(145,250,100,0);
  gdx_settextentry(indi_crem_date_t,indi_crem_date);

  label26=gdx_label("Crem. Place:",60,285,0);
  gdx_setlabelbg("images/bg.xpm",1,label26);
  indi_crem_plac_t=gdx_textentry(145,275,350,0);
  gdx_settextentry(indi_crem_plac_t,indi_crem_plac);

  label33 = gdx_label("Crem. Note:",60,310,0);
  gdx_setlabelbg("images/bg.xpm",1,label33);
  indi_crem_note_t=gdx_textentry(145,300,350,0);
  gdx_settextentry(indi_crem_note_t,indi_crem_note);





  gdx_main();
  x_close();

  return(0);
}

